=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2009-03-17 02:19:20 +0000
+++ loggerhead/controllers/revision_ui.py	2009-03-17 02:40:57 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import simplejson
 from StringIO import StringIO
 
 import bzrlib.diff
@@ -216,6 +217,7 @@
             'change': change,
             'diffs': diffs,
             'specific_path': path,
+            'json_specific_path': simplejson.dumps(path),
             'start_revid': start_revid,
             'filter_file_id': filter_file_id,
             'util': util,

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2009-03-16 06:44:50 +0000
+++ loggerhead/templates/revision.pt	2009-03-17 02:40:57 +0000
@@ -11,6 +11,9 @@
               tal:attributes="href python:branch.static_url('/static/css/diff.css')"/>
         <script type="text/javascript"
                 tal:attributes="src python:branch.static_url('/static/javascript/diff.js')"></script>
+        <script type="text/javascript">
+          var specific_path = <tal:b content="json_specific_path" />;
+        </script>
       </metal:block>
     </head>
 
@@ -113,19 +116,28 @@
              tal:repeat="item diffs">
 
           <div class="diffBox">
-            <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png');
-                                 title python:branch.static_url('/static/images/treeCollapsed.png');
-                                 alt python:branch.static_url('/static/images/treeExpanded.png')"
-                 class="expand_diff" />
             <a tal:attributes="href python:url(['/revision', change.revno, item.filename], clear=1);
                                id string:${item/filename};
-                               title string:View changes to ${item/filename} only"
-               tal:content="item/filename">
-            </a>
-          </div>
+                               title string:View changes to ${item/filename} only">
+              <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png');
+                                   title python:branch.static_url('/static/images/treeCollapsed.png');
+                                   alt python:branch.static_url('/static/images/treeExpanded.png')"
+                   class="expand_diff" tal:condition="not:specific_path" />
+              <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png');
+                                   title python:branch.static_url('/static/images/treeCollapsed.png');
+                                   alt python:branch.static_url('/static/images/treeExpanded.png')"
+                   class="expand_diff" tal:condition="specific_path" />
+              <tal:b content="item/filename" />
+              </a>
+            </div>
           <div style="overflow: hidden">
             <div class="container">
-              <div class="diffinfo">
+              <div class="loading" style="display:none">
+                <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
+              </div>
+              <div class="source_target" tal:condition="not:specific_path">
+              </div>
+              <div class="diffinfo" tal:condition="specific_path">
                 <div class="pseudotable unified"
                      tal:repeat="chunk item/chunks">
 

